/*
   fuse - associative image reconstruction
   Copyright (C) 1997  Scott Draves <spot@cs.cmu.edu>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/



#define CLIP(image1, x1, y1, w, h) \
  if (1) { int t; \
  if (x1 < 0) {w += x1; x1 = 0;} \
  if (y1 < 0) {h += y1; y1 = 0;} \
  if ((t = image1->width - x1 - w) < 0) w += t; \
  if ((t = image1->height - y1 - h) < 0) h += t;}

#define ASSEMBLE(r,g,b) ((r)|((g)<<8)|((b)<<16))
#define FRAG(p,v) \
if (1) {v[0] = (p)&0xff; \
v[1] = (((p)&0xff00)>>8); \
v[2] = (((p)&0xff0000)>>16);}

#define uint unsigned long
typedef struct {
  uint *pixels;
  int width, height;
} image;

extern void flip_coefs();
extern void blit();
extern image *read_image();
extern void write_image();
extern image *new_image();
extern void  free_image();
